diff --exclude=CVS -Nru certi/libRTI/RTIambassador.cc certi.new/libRTI/RTIambassador.cc
--- certi/libRTI/RTIambassador.cc	2008-11-21 14:41:52.000000000 +0100
+++ certi.new/libRTI/RTIambassador.cc	2008-12-05 18:27:42.000000000 +0100
@@ -1643,16 +1644,16 @@
 // Next Event Request
 void
 RTI::RTIambassador::nextEventRequest(const FedTime& theTime)
-    throw (TimeAdvanceAlreadyInProgress,
-           FederationTimeAlreadyPassed,
-           InvalidFederationTime,
-           EnableTimeRegulationPending, //not implemented
-           EnableTimeConstrainedPending, //not implemented
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::TimeAdvanceAlreadyInProgress,
+           RTI::FederationTimeAlreadyPassed,
+           RTI::InvalidFederationTime,
+           RTI::EnableTimeRegulationPending, //not implemented
+           RTI::EnableTimeConstrainedPending, //not implemented
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1682,18 +1683,18 @@
 // Flush Queue Request
 void
 RTI::RTIambassador::flushQueueRequest(const FedTime& theTime)
-    throw (TimeAdvanceAlreadyInProgress,
-           FederationTimeAlreadyPassed,
-           InvalidFederationTime,
-           EnableTimeRegulationPending, //not implemented
-           EnableTimeConstrainedPending, //not implemented
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::TimeAdvanceAlreadyInProgress,
+           RTI::FederationTimeAlreadyPassed,
+           RTI::InvalidFederationTime,
+           RTI::EnableTimeRegulationPending, //not implemented
+           RTI::EnableTimeConstrainedPending, //not implemented
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
-    throw RTIinternalError("Unimplemented Service flushQueueRequest");
+    throw RTI::RTIinternalError("Unimplemented Service flushQueueRequest");
     Message req, rep ;
 
     req.type = Message::FLUSH_QUEUE_REQUEST ;
@@ -1738,11 +1739,11 @@
 // Query LBTS
 void
 RTI::RTIambassador::queryLBTS(FedTime& theTime)
-    throw (FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1756,11 +1757,11 @@
 // Query Federate Time
 void
 RTI::RTIambassador::queryFederateTime(FedTime& theTime)
-    throw (FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1774,11 +1775,11 @@
 // Query Minimum Next Event Time
 void
 RTI::RTIambassador::queryMinNextEventTime(FedTime& theTime)
-    throw (FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1786,7 +1787,6 @@
     privateRefs->executeService(&req, &rep);
 
     theTime = rep.getFedTime();
-
 }
 
 // ----------------------------------------------------------------------------
@@ -1809,11 +1809,11 @@
 // Query Lookahead
 void
 RTI::RTIambassador::queryLookahead(FedTime &theTime)
-    throw (FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -1825,7 +1825,7 @@
         ret = RTIfedTime((Double) rep.getFederationTimeDelta());
     }
     catch (std::bad_cast) {
-	throw RTIinternalError("theTime is not a RTIfedTime object");
+	throw RTI::RTIinternalError("theTime is not a RTIfedTime object");
     }
 }
 
@@ -1837,7 +1837,7 @@
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::InvalidRetractionHandle)
 {
-    throw RTIinternalError("Unimplemented Service retract");
+    throw RTI::RTIinternalError("Unimplemented Service retract");
     Message req, rep ;
 
     req.type = Message::RETRACT ;
@@ -1862,7 +1862,7 @@
     req.type = Message::CHANGE_ATTRIBUTE_ORDER_TYPE ;
     req.setObject(theObject);
     req.setOrdering(theType);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1894,20 +1894,20 @@
  */
 RTI::Region *
 RTI::RTIambassador::createRegion(SpaceHandle space, ULong nb_extents)
-    throw (SpaceNotDefined,
-           InvalidExtents,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::SpaceNotDefined,
+           RTI::InvalidExtents,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
     req.setType(Message::DDM_CREATE_REGION);
     req.setSpace(space);
     req.setNumber(nb_extents);
     privateRefs->executeService(&req, &rep);
-    Region *region = new FedRegion(rep.getRegion(), space,
+    RTI::Region *region = new RegionImp(rep.getRegion(), space,
 				   std::vector<Extent>(nb_extents,
 						       Extent(rep.getNumber())));
 
@@ -1922,13 +1922,13 @@
  */
 void
 RTI::RTIambassador::notifyAboutRegionModification(Region &r)
-    throw (RegionNotKnown,
-           InvalidExtents,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::RegionNotKnown,
+           RTI::InvalidExtents,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     try {
 	FedRegion &region = dynamic_cast<FedRegion &>(r);
@@ -1958,13 +1958,13 @@
  */
 void
 RTI::RTIambassador::deleteRegion(Region *region)
-    throw (RegionNotKnown,
-           RegionInUse,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::RegionNotKnown,
+           RTI::RegionInUse,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     if (region == 0) {
         throw RegionNotKnown("");
@@ -1992,18 +1992,18 @@
                                                 AttributeHandle attrs[],
                                                 Region *regions[],
                                                 ULong nb)
-    throw (ObjectClassNotDefined,
-           ObjectClassNotPublished,
-           AttributeNotDefined,
-           AttributeNotPublished,
-           RegionNotKnown,
-           InvalidRegionContext,
-           ObjectAlreadyRegistered,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectClassNotDefined,
+           RTI::ObjectClassNotPublished,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotPublished,
+           RTI::RegionNotKnown,
+           RTI::InvalidRegionContext,
+           RTI::ObjectAlreadyRegistered,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2027,17 +2027,17 @@
                                                 AttributeHandle attrs[],
                                                 Region *regions[],
                                                 ULong nb)
-    throw (ObjectClassNotDefined,
-           ObjectClassNotPublished,
-           AttributeNotDefined,
-           AttributeNotPublished,
-           RegionNotKnown,
-           InvalidRegionContext,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectClassNotDefined,
+           RTI::ObjectClassNotPublished,
+           RTI::AttributeNotDefined,
+           RTI::AttributeNotPublished,
+           RTI::RegionNotKnown,
+           RTI::InvalidRegionContext,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2063,15 +2063,15 @@
 RTI::RTIambassador::associateRegionForUpdates(Region &region,
                                          ObjectHandle object,
                                          const AttributeHandleSet &attributes)
-    throw (ObjectNotKnown,
-           AttributeNotDefined,
-           InvalidRegionContext,
-           RegionNotKnown,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::AttributeNotDefined,
+           RTI::InvalidRegionContext,
+           RTI::RegionNotKnown,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     D[pdDebug] << "+ Associate Region for Updates" << endl ;
 
@@ -2080,7 +2080,7 @@
     req.type = Message::DDM_ASSOCIATE_REGION ;
     req.setObject(object);
     req.setRegion(get_handle(region));
-    req.setAHS(attributes);
+    req.setAHS(cast<AttributeHandleSetImp>()(attributes).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
     D[pdDebug] << "- Associate Region for Updates" << endl ;
@@ -2096,14 +2096,14 @@
 void
 RTI::RTIambassador::unassociateRegionForUpdates(Region &region,
                                            ObjectHandle object)
-    throw (ObjectNotKnown,
-           InvalidRegionContext,
-           RegionNotKnown,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectNotKnown,
+           RTI::InvalidRegionContext,
+           RTI::RegionNotKnown,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     D[pdDebug] << "+ Unassociate Region for Updates" << endl ;
     Message req, rep ;
@@ -2130,15 +2130,15 @@
     Region &region,
     const AttributeHandleSet &attributes,
     Boolean passive)
-    throw (ObjectClassNotDefined,
-           AttributeNotDefined,
-           RegionNotKnown,
-           InvalidRegionContext,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectClassNotDefined,
+           RTI::AttributeNotDefined,
+           RTI::RegionNotKnown,
+           RTI::InvalidRegionContext,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     D[pdDebug] << "+ Subscribe Object Class Attributes with Region" << endl ;
     Message req, rep ;
@@ -2146,7 +2146,7 @@
     req.type = Message::DDM_SUBSCRIBE_ATTRIBUTES ;
     req.setObjectClass(object_class);
     req.setRegion(get_handle(region));
-    req.setAHS(attributes);
+    req.setAHS(cast<AttributeHandleSetImp>()(attributes).getAttributeHandles());
     req.setBoolean(passive);
 
     privateRefs->executeService(&req, &rep);
@@ -2162,14 +2162,14 @@
 void
 RTI::RTIambassador::unsubscribeObjectClassWithRegion(ObjectClassHandle object_class,
                                                 Region &region)
-    throw (ObjectClassNotDefined,
-           RegionNotKnown,
-           ObjectClassNotSubscribed,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::ObjectClassNotDefined,
+           RTI::RegionNotKnown,
+           RTI::ObjectClassNotSubscribed,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     D[pdDebug] << "+ Unsubscribe Object Class " << object_class
 	       << " with Region" << endl ;
@@ -2189,15 +2189,15 @@
 RTI::RTIambassador::subscribeInteractionClassWithRegion(InteractionClassHandle ic,
                                                    Region &region,
                                                    RTI::Boolean passive)
-    throw (InteractionClassNotDefined,
-           RegionNotKnown,
-           InvalidRegionContext,
-           FederateLoggingServiceCalls,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::RegionNotKnown,
+           RTI::InvalidRegionContext,
+           RTI::FederateLoggingServiceCalls,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2214,14 +2214,14 @@
 void
 RTI::RTIambassador::unsubscribeInteractionClassWithRegion(InteractionClassHandle ic,
                                                      Region &region)
-    throw (InteractionClassNotDefined,
-           InteractionClassNotSubscribed,
-           RegionNotKnown,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::InteractionClassNotSubscribed,
+           RTI::RegionNotKnown,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2240,27 +2240,27 @@
                                          const FedTime &time,
                                          const char *tag,
                                          const Region &region)
-    throw (InteractionClassNotDefined,
-           InteractionClassNotPublished,
-           InteractionParameterNotDefined,
-           InvalidFederationTime,
-           RegionNotKnown,
-           InvalidRegionContext,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::InteractionClassNotPublished,
+           RTI::InteractionParameterNotDefined,
+           RTI::InvalidFederationTime,
+           RTI::RegionNotKnown,
+           RTI::InvalidRegionContext,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
     req.setType(Message::SEND_INTERACTION);
     req.setInteractionClass(interaction);
-    req.setPHVPS(par);
+    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(par).getParameterHandleValuePairs());
     req.setFedTime(time);
     if ( tag == NULL )
        {
-       throw RTIinternalError ("Calling sendInteractionWithRegion with Tag NULL");
+       throw RTI::RTIinternalError ("Calling sendInteractionWithRegion with Tag NULL");
        }
     req.setTag(tag);
     req.setRegion(get_handle(region));
@@ -2276,25 +2276,25 @@
                                          const ParameterHandleValuePairSet &par,
                                          const char *tag,
                                          const Region &region)
-    throw (InteractionClassNotDefined,
-           InteractionClassNotPublished,
-           InteractionParameterNotDefined,
-           RegionNotKnown,
-           InvalidRegionContext,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           SaveInProgress,
-           RestoreInProgress,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::InteractionClassNotPublished,
+           RTI::InteractionParameterNotDefined,
+           RTI::RegionNotKnown,
+           RTI::InvalidRegionContext,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::SaveInProgress,
+           RTI::RestoreInProgress,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
     req.setType(Message::SEND_INTERACTION);
     req.setInteractionClass(interaction);
-    req.setPHVPS(par);
+    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(par).getParameterHandleValuePairs());
     if ( tag == NULL )
        {
-       throw RTIinternalError ("Calling sendInteractionWithRegion with Tag NULL");
+       throw RTI::RTIinternalError ("Calling sendInteractionWithRegion with Tag NULL");
        }
     req.setTag(tag);
     req.setRegion(get_handle(region));
@@ -2312,11 +2312,11 @@
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::RegionNotKnown, RTI::AttributeNotDefined, RTI::ObjectClassNotDefined)
 {
-    throw UnimplementedService("");
+    throw RTI::RTIinternalError("unimplemented service requestClassAttributeValueUpdateWithRegion");
 
     Message req, rep ;
     req.setType(Message::DDM_REQUEST_UPDATE);
-    req.setAHS(attrs);
+    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
     req.setRegion(get_handle(region));
     privateRefs->executeService(&req, &rep);    
 }
@@ -2327,10 +2327,10 @@
  */
 ObjectClassHandle
 RTI::RTIambassador::getObjectClassHandle(const char *theName)
-    throw (NameNotFound,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::NameNotFound,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2353,10 +2353,10 @@
 */
 char *
 RTI::RTIambassador::getObjectClassName(ObjectClassHandle handle)
-    throw (ObjectClassNotDefined,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::ObjectClassNotDefined,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
     req.type = Message::GET_OBJECT_CLASS_NAME ;
@@ -2373,12 +2373,11 @@
 AttributeHandle
 RTI::RTIambassador::getAttributeHandle(const char *theName,
                                   ObjectClassHandle whichClass)
-    throw (ObjectClassNotDefined,
-           NameNotFound,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
-
+    throw (RTI::ObjectClassNotDefined,
+           RTI::NameNotFound,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     G.Out(pdGendoc,"enter RTI::RTIambassador::getAttributeHandle");
     Message req, rep ;
@@ -2399,11 +2398,11 @@
 char *
 RTI::RTIambassador::getAttributeName(AttributeHandle theHandle,
                                 ObjectClassHandle whichClass)
-    throw (ObjectClassNotDefined,
-           AttributeNotDefined,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::ObjectClassNotDefined,
+           RTI::AttributeNotDefined,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
     req.type = Message::GET_ATTRIBUTE_NAME ;
@@ -2417,10 +2416,10 @@
 // Get Interaction Class Handle
 InteractionClassHandle
 RTI::RTIambassador::getInteractionClassHandle(const char *theName)
-    throw (NameNotFound,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::NameNotFound,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2436,10 +2435,10 @@
 // Get Interaction Class Name
 char *
 RTI::RTIambassador::getInteractionClassName(InteractionClassHandle theHandle)
-    throw (InteractionClassNotDefined,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2456,11 +2455,11 @@
 ParameterHandle
 RTI::RTIambassador::getParameterHandle(const char *theName,
                                   InteractionClassHandle whichClass)
-    throw (InteractionClassNotDefined,
-           NameNotFound,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::NameNotFound,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2478,11 +2477,11 @@
 char *
 RTI::RTIambassador::getParameterName(ParameterHandle theHandle,
                                 InteractionClassHandle whichClass)
-    throw (InteractionClassNotDefined,
-           InteractionParameterNotDefined,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+           RTI::InteractionParameterNotDefined,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
 
@@ -2535,10 +2534,10 @@
  */
 SpaceHandle
 RTI::RTIambassador::getRoutingSpaceHandle(const char *rs_name)
-    throw (NameNotFound,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::NameNotFound,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     D[pdDebug] << "Get routing space handle: " << rs_name << endl ;
     Message req, rep ;
@@ -2554,10 +2553,10 @@
  */
 char *
 RTI::RTIambassador::getRoutingSpaceName(SpaceHandle handle)
-    throw (SpaceNotDefined,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::SpaceNotDefined,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
     req.type = Message::GET_SPACE_NAME ;
@@ -2574,11 +2573,11 @@
 DimensionHandle
 RTI::RTIambassador::getDimensionHandle(const char *dimension,
                                   SpaceHandle space)
-    throw (SpaceNotDefined,
-           NameNotFound,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::SpaceNotDefined,
+           RTI::NameNotFound,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
     req.type = Message::GET_DIMENSION_HANDLE ;
@@ -2596,11 +2595,11 @@
 char *
 RTI::RTIambassador::getDimensionName(DimensionHandle dimension,
                                 SpaceHandle space)
-    throw (SpaceNotDefined,
-           DimensionNotDefined,
-           FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::SpaceNotDefined,
+           RTI::DimensionNotDefined,
+           RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
     req.type = Message::GET_DIMENSION_NAME ;
@@ -2619,11 +2618,11 @@
 SpaceHandle
 RTI::RTIambassador::getAttributeRoutingSpaceHandle(AttributeHandle attribute,
                                               ObjectClassHandle object_class)
-    throw (ObjectClassNotDefined,
-	   AttributeNotDefined,
-           FederateNotExecutionMember,
-	   ConcurrentAccessAttempted,
-           RTIinternalError)
+    throw (RTI::ObjectClassNotDefined,
+	   RTI::AttributeNotDefined,
+           RTI::FederateNotExecutionMember,
+	   RTI::ConcurrentAccessAttempted,
+           RTI::RTIinternalError)
 {
     Message req, rep ;
     req.type = Message::GET_ATTRIBUTE_SPACE_HANDLE ;
@@ -2654,10 +2653,10 @@
  */
 SpaceHandle
 RTI::RTIambassador::getInteractionRoutingSpaceHandle(InteractionClassHandle inter)
-    throw (InteractionClassNotDefined,
-	   FederateNotExecutionMember,
-           ConcurrentAccessAttempted,
-	   RTIinternalError)
+    throw (RTI::InteractionClassNotDefined,
+	   RTI::FederateNotExecutionMember,
+           RTI::ConcurrentAccessAttempted,
+	   RTI::RTIinternalError)
 {
     Message req, rep ;
     req.type = Message::GET_INTERACTION_SPACE_HANDLE ;
